(ns blog.helpers
  (:require ["date-fns" :refer [format]]))

(defn truncatestring-factory
  []
  (fn [text limit]
    (if (> (. text -length) limit)
      (-> (. text substring 0 limit)
          (str  "..."))
      text)))

(defn full-timestamp-factory
  []
  (clj->js
   (fn [timestamp]
     (format timestamp "HH:mm MMM. do, yyyy"))))

(defn article-timestamp-factory
  []
  (clj->js
   (fn [timestamp]
     (str "<time pubdate=\""
          (format timestamp "yyyy-MM-dd")
          "\" datetime=\""
          (format timestamp "yyyy-MM-dd")
          "\" title=\""
          (format timestamp "MMMM do, yyyy")
          "\">"
          (format timestamp "MMMM do, yyyy")
          "</time>"))))

(defn is-brief-factory
  []
  (clj->js
   (fn [length]
     (if (> length 60)
       "..."
       ""))))

